package ch.metas.soa.prototyping.jboss.marshalling.ejb;

import javax.ejb.LocalBean;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.NoResultException;
import javax.persistence.PersistenceContext;
import javax.persistence.TypedQuery;

import ch.metas.soa.prototyping.jboss.marshalling.models.Book;
import ch.metas.soa.prototyping.jboss.marshalling.models.BookShelf;

@Stateless
@LocalBean
public class DAO {

	private EntityManager m_em;

	public EntityManager getEntityManager() {
		return m_em;
	}

	@PersistenceContext
	protected void setEntityManager(EntityManager em) {
		m_em = em;
	}

	public BookShelf save(BookShelf bookShelf) {
		m_em.persist(bookShelf);
		return bookShelf;
	}

	public Book save(Book book) {
		m_em.persist(book);
		return book;
	}

	public BookShelf findFirstBookShelfById(int id) {
		try {
			TypedQuery<BookShelf> query = getEntityManager().createQuery(
				"select b FROM BookShelf b WHERE b.id=?", BookShelf.class);
			query.setParameter(1, id);
			return query.getSingleResult();
		}
		catch (NoResultException nre) {
			return null;
		}
	}

	public Book findFirstBookById(int id) {
		try {
			TypedQuery<Book> query = getEntityManager().createQuery(
				"select b FROM Book b WHERE b.id=?", Book.class);
			query.setParameter(1, id);
			return query.getSingleResult();
		}
		catch (NoResultException nre) {
			return null;
		}
	}
}
