package ch.metas.soa.prototyping.jboss.marshalling.ejb;

import javax.ejb.EJB;
import javax.ejb.Stateless;

import ch.metas.soa.prototyping.jboss.marshalling.ifc.DemoService;
import ch.metas.soa.prototyping.jboss.marshalling.ifc.SecuredDemoService;
import ch.metas.soa.prototyping.jboss.marshalling.models.Book;
import ch.metas.soa.prototyping.jboss.marshalling.models.BookShelf;

@Stateless
public class DemoServiceProxy implements DemoService {

	@EJB(lookup = "java:global/ejb1/DemoService")
	DemoService m_proxiedService;

	@EJB(lookup = "java:global/ejb2/SecureDemoService")
	SecuredDemoService m_proxiedService2;

	/* (non-Javadoc)
	 * @see ch.metas.soa.prototyping.jboss.marshalling.ejb.DemoService#getBookShelf()
	 */
	@Override
	public BookShelf getBookShelf() {
		return m_proxiedService.getBookShelf();
	}

	@Override
	public Book getFirstBook() {
		try {
			Book firstBook = m_proxiedService.getFirstBook();
			return firstBook;
		}
		catch (Exception cnfe) {
			cnfe.printStackTrace();
			Book firstBook = m_proxiedService2.getFirstBook();
			return firstBook;
		}
	}

	/* (non-Javadoc)
	 * @see ch.metas.soa.prototyping.jboss.marshalling.ejb.DemoService#initialize()
	 */
	@Override
	public void initialize() {
		m_proxiedService.initialize();
	}
}
